$discus_version = "3.10";
$pro_version = 1;

# SETUP SCRIPT FOR DISCUS ON UNIX or WINDOWS PLATFORMS
# Copyright (c) 1998-2000, Kevin W. Paulisse and William F. Polik,
#   all rights reserved.  This script may not be redistributed
#   or used except as provided in the Discus license agreement.

# Determine if you are running on Unix or Windows
# If this portion messes up, you can uncomment one of the lines
# below.  It would be a strange system for which this would not
# work, though!

if (-d "C:/" || $^O eq "MSWin32") {
	$windows = 1;
	$platform = "WINDOWS";
} elsif (-e "/etc/passwd") {
	$unix = 1;
	$platform = "UNIX";
} else {
	$unix = 1;
	$platform = "UNKNOWN PLATFORM";
}

#$unix = 1; $windows = 0;  # Uncomment this line if you have unix
#$windows = 1; $unix = 0;   # Uncomment this line if you have Windows
# No, this does not work on a Mac.  Don't even ask us about it.

print "\n\n";
print "WELCOME TO DISCUS $discus_version ";
print "PRO " if $pro_version;
print "SETUP FOR $platform\n\n";

if (open(SRC, "./source/src-board-subs-common")) {
	@src = <SRC>;
	close (SRC);
	@src = grep(/^\$/, @src);
	undef %SRC_VAR;
	foreach $line (@src) {
		if ($line =~ m|^\$(\w+)\s*=\s*"(.*)";|) {
			$SRC_VAR{$1} = $2;
		}
	}
	print "This will install Discus version $SRC_VAR{'release_version'}.";
	print "$SRC_VAR{'free_revision'} (Freeware)" if !$pro_version;
	print "$SRC_VAR{'pro_revision'} PRO" if $pro_version;
	print " onto your server.\n";
	if ($SRC_VAR{'free_revision'} =~ m|b| || $SRC_VAR{'pro_revision'} =~ m|b|) {
		print "NOTE:  THIS IS A BETA VERSION!!!\n";
	}
	print "\nIf you were expecting a different version of Discus, you should obtain\n";
	print "the correct distribution.  Freeware Discus can be downloaded from:\n";
	print "   http://www.discusware.com/discus/download.html\n";
	print "Discus Pro must be downloaded from the Discus Pro download area:\n";
	print "   http://www.discusware.com/pro/download.html\n\n";
	&press_key;
}

print "In this initial portion of setup, you will be asked a few\n";
print "simple questions.  This script will then prepare an HTML form\n";
print "which you will access with your web browser to specify your\n";
print "configuration options.\n\n";
print "IMPORTANT!  If you want to UPGRADE an existing version of Discus,\n";
print "you should be using the upgrade.pl script and not this one!\n\n";
print "Here is some information that setup has determined about your\n";
print "system.  You probably already know this.  If not, you should make\n";
print "note of these values.\n\n";
print "Current version of Perl running: $]\n";
print "This script is reported as:      $0\n" if $0 ne "setup.pl";
if ($^O =~ /\S/) {
	print "Perl thinks that this OS is:     $^O\n";
}
if ($^X =~ /\S/) {
	print "Current Perl running is:         $^X\n" if $^X ne "perl";
}

if ($windows) {
	eval 'use Win32::Registry;' if $windows;
	undef %vals;
	$p = "SOFTWARE\\Microsoft\\Windows\\CurrentVersion";
	eval '$main::HKEY_LOCAL_MACHINE->Open($p, $param) && $param->GetValues(\%vals);' if $windows;
	foreach $k (keys(%vals)) {
		$key = $vals{$k};
		eval '$win95{$$key[0]} = $$key[2];';
	}
	undef %vals;
	$p = "SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion";
	eval '$main::HKEY_LOCAL_MACHINE->Open($p, $param) && $param->GetValues(\%vals);' if $windows;
	foreach $k (keys(%vals)) {
		$key = $vals{$k};
		eval '$winnt{$$key[0]} = $$key[2];';
	}
	if ($win95{'Version'} eq "Windows 95") {
		print "Your operating system is:        Windows 95 $win95{'VersionNumber'}\n";
		$win95 = 1;
	}
	if ($winnt{'CurrentVersion'} ne "") {
		print "Your operating system is:        Windows NT $winnt{'CurrentVersion'}\n";
		$winnt = 1;
	}
} else {
   print "\n";
}

&press_key;

###################################################################
# Selection of the Perl installation to use

&divider;
print "SET UP THE PATH TO PERL\n\n";
print "It is time to determine where the Perl interpreters are\n";
print "on your system.  We recommend selecting Perl 5 if\n";
print "it is available.\n\n";

undef @perl;

if ($unix) {
	$perlint = `whereis perl`;
	if ($perlint =~ m|perl: (.*)|) {
		$pf = $1;
		@perls = split(/\s+/, $pf);
		foreach $perl_s (@perls) {
			if (&test_perl($perl_s) == 2) {
				push (@perl, $perl_s);
			}
		}
	}    
	$which = `which perl`;
	chop ($which);
	if (&test_perl($which) == 2) {
		push (@perl, $which) if !(grep(/^$which$/, @perl));
	}    
	$tries = "/usr/bin/perl /usr/bin/perl5 /usr/local/bin/perl /usr/local/bin/perl5 /usr/sbin/perl /usr/local/sbin/perl /usr/contrib/bin/perl";    
	foreach $try (split(/\s/, $tries)) {
		if (&test_perl($try) == 2) {
			push (@perl, $try) if !(grep(/^$try$/, @perl));
		}
	}
	if (scalar(@perl) > 0) {
		print "The following Perl installations were detected on your server.\n";
		print "You may choose to use one of these or you may specify another\n";
		print "Perl installation that does not appear on the list.\n";
		print "\n";
		$counter = 0;
		foreach $perl (@perl) {
			$counter++;
			print "$counter)  $perl\n";
			$perl{$counter} = $perl;
		}
		$counter++;
		print "$counter)  [Select a different Perl]\n\n";
		print "Please choose which Perl to use by entering a number from ";
		print "1 to $counter.\n\n";
		print "Your choice: ";
		$choice = <STDIN>;
		$choice =~ s/\D//g;
		if ($choice < 1 || $choice > $counter) {
			print "\nThat is an invalid choice.  Script exiting.\n\n";
			exit(0);
		}
		if ($perl{$choice}) {
			$chosen_perl = $perl{$choice};
		}
	}
	if ($chosen_perl eq "") {
		print "\nPlease enter the path to Perl on your machine.\n";
		print "Example: /usr/local/bin/perl\n\n";
		print "Your input: ";
		$input = <STDIN>;
		chop ($input);
		if (&test_perl($input) == 2) {
			$chosen_perl = $input;
		} else {
			print "\nWARNING!  The Perl installation you specified does not\n";
			print "appear to be a real Perl installation.  Are you sure you\n";
			print "want to continue anyway?\n\n";
			print "(Enter y or n)\n\n";
			print "Your answer: ";
			$ans = <STDIN>;
			exit(0) if $ans !~ /^[yY]/;
			$chosen_perl = $input;
		}
	}
	print "\n";
} else {
	undef %vals;
	$p = "SOFTWARE\\Activeware\\Perl5";
	eval '$main::HKEY_LOCAL_MACHINE->Open($p, $param) && $param->GetValues(\%vals);' if $windows;
	foreach $k (keys(%vals)) {
		$key = $vals{$k};
		eval '$perl{$$key[0]} = $$key[2];';
	}
	print "Checking for Perl...\n";
	print "   Old Active State Perl distributions... ";
	$suggest_perl = "";
	if ($perl{BIN} eq "") {
		print "not detected\n";
	} else {
		print "found!\n";
		$suggest_perl = $perl{BIN};
	}
	print "   New ActivePerl distributions...        ";
	undef %vals; undef %perl; undef @vals;
	$p = "SOFTWARE\\ActiveState\\ActivePerl"; $ap = 0;
	eval '$main::HKEY_LOCAL_MACHINE->Open($p, $param) && $param->GetKeys(\@vals);' if $windows;
	foreach $k (@vals) {
		if ($k =~ m|^\d+$|) {
			print "Build $k found!\n"; $ap = 1; last;
		}
	}
	if ($ap == 1) {
		$p = "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\Perl.exe";
		eval '$main::HKEY_LOCAL_MACHINE->Open($p, $param) && $param->GetValues(\%vals);' if $windows;		
		foreach $k (keys(%vals)) {
			$key = $vals{$k};
			eval '$perl{$$key[0]} = $$key[2];';
		}
		if ($perl{Path} ne "") {
			print "   Appears to be installed in $perl{Path}\\perl.exe\n";
			$suggested_perl = $perl{Path} . "\\perl.exe";
		}
	}
	print "   Checking running Perl...              ";
	eval '$foo = crypt("test", "test");';
	if ($@) {
		print " [Failed]\n";
		print "   Currently running Perl version does not support the 'crypt' function.\n";
		print "   Make sure that you use ActivePerl when installing Discus.\n\n";
	} else {
		print " [Passed]\n";
	}
	print "\n\n";
	print "Please choose the Perl interpreter you wish to use from this list:\n";
	undef %perlint; $count = 0;
	if ($^X ne "perl") {
		$count += 1; $perlint{$count} = $^X;
		print "$count)  $perlint{$count}\n";
	}
	if ($suggested_perl ne $^X && $suggested_perl ne "") {
		$count += 1; $perlint{$count} = $suggested_perl;
		print "$count)  $perlint{$count}\n";
	}
	$count += 1;
	print "$count)  Choose a different Perl path\n";
	print "\n";
	print "Your choice: ";
	$ctr = <STDIN>; chomp $ctr;
	if ($ctr < 1 || $ctr > $count) {
		print "Sorry... invalid choice!\n";
		exit(0);
	}
	if ($perlint{$ctr} ne "") {
		$default_perl = $perlint{$ctr};
	} else {
		print "\nEnter your full path to Perl here:\n";
		$answer = <STDIN>;
		chop ($answer);
		$perl_selected = $answer;
		$perl_selected =~ s/\\/\//g;
		if (!(-e ($perl_selected))) {
			die("That path is invalid.  I checked it and it didn't exist.\n");
		}
		$default_perl = $perl_selected;
	}
	$chosen_perl = $default_perl;
	$chosen_perl =~ s/\\/\//g;
}

###################################################################
# Selection of the CGI extension

&divider;
print "SET UP CGI EXTENSION\n\n";

print "What is the extension on your server that will cause the\n";
print "server to execute files as CGI scripts?  On many servers,\n";
print "this is '.cgi'.  On some servers, however, this is '.pl'.\n";
print "And on some servers, it doesn't matter.\n\n";
print "If you're not sure, choose '.cgi' (option 1) and see if it works.\n\n";
print "1)  .cgi\n";
print "2)  .pl\n";
print "3)  [Specify other extension]\n\n";
print "Your choice: ";
$choice = <STDIN>;
$choice =~ s/\D//g;
if ($choice < 1 || $choice > 3) {
	print "\nThat is an invalid choice.  Script exiting.\n\n";
	exit(0);
}
if ($choice == 1) {
	$cgi_extension = "cgi";
} elsif ($choice == 2) {
	$cgi_extension = "pl";
} else {
	print "\nSpecify which CGI extension to use: ";
	$ans = <STDIN>;
	$ans =~ s/\W//g;
	if ($ans eq "") {
		print "\nThat is not a valid extension.  Script exiting.\n\n";
	}
	$cgi_extension = $ans;
}

&divider;
print "SET UP CGI DIRECTORY\n\n";
print "The script that is currently running will create a file called\n";
print "board-setup.$cgi_extension that will continue the setup.\n";
print "This script needs to be placed in a directory that meets\n";
print "the following requirements:\n\n";
print "  - Directory is in the server's webspace\n";
print "  - Execution of CGI scripts is permitted in directory\n\n";
print "In addition, you need to be able to write to this directory\n";
print "(so I can create the board-setup.$cgi_extension file there).\n\n";
if ($unix) {
	print "Example:  /home/httpd/cgi-bin\n";
} elsif ($windows) {
	print "Example:  C:\\InetPub\\Scripts\n";
}
$chosen_dir = "";

while ($chosen_dir eq "") {
	print "\nEnter a directory, or just hit ENTER to quit.\n";
	print "\nDirectory: ";
	$dirin = <STDIN>;
	chop ($dirin);
	$dirin =~ s/\\/\//g;
	if ($dirin eq "") {
		exit(0);
	}
	if (!(-d $dirin)) {
		print "That directory doesn't exist.\n";
 	} elsif (!(-w $dirin) && $unix) {
		print "You can't write to that directory.\n";
	} elsif ($dirin !~ /^\// && $unix) {
		print "Your directory specification must start with a / character\n";
		print "as it must be an absolute directory.  You cannot use ~ to\n";
		print "indicate your home directory, nor . to use a relative\n";
		print "directory.\n";
		$chosen_dir = "";
	} else {
		$chosen_dir = $dirin;
	}
}
$chosen_dir =~ s/\/$//;
$chosen_dir = "/" if $chosen_dir eq "";
&divider;

if ($unix) {
	print "CHOOSE SETUP METHOD\n\n";
	print "Which of the following looks most like the URL at which the\n";
	print "Discus board will be available following setup?\n\n";
	print "The major difference here is that choice 1 indicates that you\n";
	print "will be installing off your home directory, likely putting the\n";
	print "files into a 'public_html' (or similar) directory.  Choice 2 is\n";
	print "used to install into your server's directory tree, which is\n";
	print "generally applicable for virtual domains or if you are the\n";
	print "webmaster of your server.\n\n";
	eval '$whoami = (getpwuid($<))[0];';
	eval '$your_name = (getpwuid($<))[6];';
	eval '$home_dir = (getpwuid($<))[7];';
	if ($whoami eq "root") {
		$whoami_temp = "username";
	} elsif ($whoami eq "") {
		$whoami_temp = "username";
  	} else {
		$whoami_temp = $whoami;
	}    
	$tries = "public_html www htdocs html WWW";
	@tries = split(/\s/, $tries);
	foreach $try (@tries) {
		if (-e "$home_dir/$try") {
			$www_dir = $try;
			last;
		}
	}
	$www_dir = "public_html" if $www_dir eq "";
	$home_dir = "/home/smith" if $home_dir !~ /\w/;
	$hostname = $ENV{'HOST'};
	if ($hostname eq "") {
		$hostname = $ENV{'HOSTNAME'};
		if ($hostname eq "") {
			$hostname_t = `hostname`;
			chop ($hostname_t);
			$hostname = $hostname_t;
		}
	}
	print "1)  http://$hostname/~$whoami_temp/discus\n";
	print "2)  http://$hostname/discus\n";
	print "3)  Don't know\n\n";
	print "Your choice: ";
	$method = <STDIN>;
	$method = 2 if $method == 3;
	if ($method < 1 || $method > 2) {
		print "\nThat's not a valid method.\n\n";
		exit(0);
	}
	&divider;
}

$method = 3 if $windows;
$method = 2 if $method == 0;

if ($pro_version == 1) {
	$flag = 1;
	print "\nDISCUS PRO LICENSE NUMBER\n\n";
	print "Please enter your Discus Pro license number.  This license number\n";
	print "will have the form ####-####-####.  If you did not receive this\n";
	print "license number from Discus, please e-mail sales\@discusware.com.\n\n";
	while ($flag == 1) {
		print "ENTER LICENSE NUMBER>  ";
		$pro_license = <STDIN>;
		chop ($pro_license);
	
	# There is not anything in the script that would break if you gave a wrong license
	# number.  This is entered for YOUR protection, so you know that you paid, should
	# this ever become an issue.  Thus, we STRONGLY recommend entering a real license
	# number.  You have been told.  Besides, do you think it is wise to use pirated
	# software in a networked environment where you are so easily caught?
	
		if ($pro_license eq "") {
			print "Please visit the website http://www.chem.hope.edu/discus/pro to purchase\n";
			print "a license and to receive a license number.\n\n";
			exit(0);
		} elsif ($pro_license !~ m|^\d\d\d\d-\d\d\d\d-\d\d\d\d|) {
			print "That license number is not in the form ####-####-####.  Please check\n";
			print "your license number and try again.\n\n";
		} elsif ($pro_license eq "0000-0000-0000") {
			print "Please visit the website http://www.chem.hope.edu/discus/pro to purchase\n";
			print "a license and to receive a license number.\n\n";
			exit(0);
		} else {
		
			# This operation is check-summing your license information to help you catch
			# typographical errors.  Sure, you could easily circumvent it, but why would
			# you want to do that, unless you didn't have a valid license number!?!
		
			($first, $second, $third) = split(/-/, $pro_license);
			
			$f[0] = substr($first, 0, 1);
			$f[1] = substr($first, 1, 1);
			$f[2] = substr($first, 2, 1);
			$f[3] = substr($first, 3, 1);
			$s[0] = substr($second, 0, 1);
			$s[1] = substr($second, 1, 1);
			$s[2] = substr($second, 2, 1);
			$s[3] = substr($second, 3, 1);
			$t[0] = substr($third, 0, 1);
			$t[1] = substr($third, 1, 1);
			$t[2] = substr($third, 2, 1);
			$t[3] = substr($third, 3, 1);
			
			if ((($f[0] + $s[0]) % 10 != $t[0]) || (($f[1] + $s[1]) % 10 != $t[1]) || (($f[2] + $s[2]) % 10 != $t[2]) || (($f[3] + $s[3]) % 10 != $t[3])) {
				print "The license number you entered is not valid.  Please double-check\n";
				print "your license number and try again.\n\n";
			} else {
				last;
			}
		}
	}
}

if (-e "./source/languages") {
	$count = 1;
	undef %lang; $language = "";
	$lang{1} = "English";
	opendir(DIR, "./source/languages");
	while ($dir = readdir(DIR)) {
		if ($dir =~ m|^\w+$|) {
			$count += 1;
			$lang{$count} = $dir;
		}
	}
	closedir(DIR);
	print "\n\n";
	print "SELECT LANGUAGE\n\n";
	print "Please choose the language you wish to install:\n\n";
	for ($i = 1; $i <= $count; $i++) {
		print "$i) \u$lang{$i}\n";
	}
	print "\n";
	print "Your answer: ";
	$lang = <STDIN>; chomp $lang;
	if ($lang < 1 || $lang > $count) {
		print "Invalid selection!\n";
		exit(0);
	}
	$language_selected = $lang{$lang} if $lang >= 2;
	$language_chosen = $language_selected;
}
print "\n\n";
print "CONFIRM SETUP\n\n";
print "This setup script has finished taking answers from you, and it\n";
print "is time to prepare the setup form that you will access with your\n";
print "web browser.  Before that is done, please verify the following\n";
print "setup options that you have specified:\n\n";

if ($windows) {
	print "WINDOWS NOTE:  Backslashes, \\, are automatically converted to forward\n";
	print "slashes, /, for compatability.  Do not be concerned about this\n";
	print "conversion.\n\n";
}
print "Perl:             $chosen_perl\n";
print "CGI Extension :   $cgi_extension   (NOTE: '.' has been removed)\n";
print "CGI Directory:    $chosen_dir\n";
if ($unix) {
	print "Setup method:     ";
	print "http://your.server.com/~$whoami_temp/discus" if $method == 1;
	print "http://your.server.com/discus" if $method == 2;
	print "\n\n";
} else {
	print "\n";
}

print "Continue with setup using these settings? (y or n)\n\n";
print "Your answer: ";
$cont = <STDIN>;
exit(0) if $cont !~ /^[yY]/;

&divider;

undef @cwd;
if ($unix) {
	$pwd = `pwd`;
	chop ($pwd) if $pwd =~ m|\n$|;
	push (@cwd, $pwd) if $pwd ne "";
}

push (@cwd, $ENV{'PWD'}) if $ENV{'PWD'} ne "";
if (!eval 'use Cwd;') {
	eval '$cwd = cwd();';
	push (@cwd, $cwd);
}
$p_dir = "";
foreach $dir (@cwd) {
	if (-d $dir && -e "$dir/setup.pl") {
		$p_dir = $dir;
		last;
	}
}
if ($p_dir eq "") {
	print "OOPS!  DIRECTORY DETERMINATION FAILED\n\n";
	print "I could not determine the directory that this script\n";
	print "is in.  This is because your system does not support the 'pwd'\n";
	print "command, the environment variable is not set, and the 'cwd'\n";
	print "module of your Perl installation doesn't work.\n\n";
	print "Please type the name of the current directory.\n\n";
	if ($unix) {
		print "Example:  /home/smith/download/discus2_xx\n\n";
	} else {
		print "Example:  C:\\Temp\\discus2_xx\n\n";
	}
	print "Directory: ";
	$dir = <STDIN>;
	chop ($dir);
	$dir =~ s/\\/\//g;
	$dir =~ s/\/$//;
	if (-d $dir || -e "$dir/setup.pl") {
		$p_dir = $dir;
	} else {
		print "Nope, that's not it.  The 'setup.pl' script does\n";
		print "not exist in the directory you specified...\n\n";
		exit(0);
	}
	if ($dir !~ /^\// && $unix) {
		print "Your directory specification must start with a / character\n";
		print "as it must be an absolute directory.  You cannot use ~ to\n";
		print "indicate your home directory, nor . to use a relative\n";
		print "directory.\n\n";
		exit(0);
	}
	&divider;
}

print "PREPARING SETUP FORM AND INSTALLATION FILES\n\n";
if (open (FILE, ">$p_dir/install.pl")) {
	print FILE "#!", $chosen_perl, "\n";
	print FILE "#Generated installation script\n";
	print FILE "#THIS FILE IS DYNAMICALLY GENERATED!  DO NOT EDIT!\n\n";
	close (FILE);
	print "Created and wrote install.pl\n";
} else {
	print "Error: could not write to 'install.pl', probably because\n";
	print "you don't have write permissions to the current directory.\n";
	exit(0);
}

if (open (FILE, ">$p_dir/uninstall.pl")) {
	print FILE "#!", $chosen_perl, "\n";
	print FILE "#Generated uninstall script\n";
	print FILE "THIS FILE IS DYNAMICALLY GENERATED!  DO NOT EDIT!\n\n";
	close (FILE);
	print "Created and wrote uninstall.pl\n";
} else {
	print "Error: could not write to 'uninstall.pl', probably because\n";
	print "you don't have write permissions to the current directory.\n";
	exit(0);
}

if (eval 'chmod (0766, "$p_dir/install.pl");') {
	$implemented_chmod = 1;
} else {
	$implemented_chmod = 0;
}

eval 'chmod (0766, "$p_dir/uninstall.pl");';

if (open (FILE, ">$chosen_dir/board-setup.$cgi_extension")) {
	print FILE "#!", $chosen_perl, "\n";
	print FILE "# Generated board setup script\n\n";
	print FILE "#" x 50, "\n";
	print FILE "# VARIABLES FROM THE FIRST SETUP SCRIPT\n\n";
	print FILE "\$chosen_perl = '$chosen_perl';\n";
	print FILE "\$install_dir = '$p_dir';\n";
	print FILE "\$cgi_extension = '$cgi_extension';\n";
	print FILE "\$chosen_dir = '$chosen_dir';\n";
	print FILE "\$uid = '$whoami';\n";
	print FILE "\$hostname = '$hostname';\n";
	print FILE "\$your_name = '$your_name';\n";
	print FILE "\$home = '$home_dir';\n";
	print FILE "\$www_subdir = '$www_dir';\n";
	print FILE "\$unix = '$unix';\n";
	print FILE "\$windows = '$windows';\n";
	print FILE "\$win95 = '$win95';\n";
	print FILE "\$nt = '$winnt';\n";
	print FILE "\$language_chosen = '$language_chosen';\n" if $language_chosen;
	print FILE "\$DISCUS_VERSION = '$discus_version';\n";
$pro_version = 1;
	print FILE "\$pro_license = '$pro_license';\n";
	print FILE "\$pro_version = '$pro_version';\n" if $pro_version;
	print FILE "\n";
	print FILE "#" x 50, "\n";
	print FILE "# SCRIPT READ IN FROM src-board-setup\n\n";
	if (open (SOURCE, "$p_dir/source/src-board-setup")) {
		while (<SOURCE>) {
			print FILE;
		}
		close (SOURCE);
	} else {
		print "Error: I could not open the file $p_dir/source/src-board-setup\n";
		print "for reading (reason: $!).  Check permissions and check that you\n";
		print "have properly extracted the archive, then try again.\n\n";
		exit(0);
	} 
	print FILE "#" x 50, "\n";
	print FILE "# WWW SETUP FORM CODE READ FROM src-setup-$method\n\n";
	print FILE "sub display_form {\n";
	print FILE "\tprint \"Content-type: text/html\\n\\n\";\n";
	if (open (METHOD, "$p_dir/source/src-setup-$method")) {
		@method = <METHOD>;
		close (METHOD);
	} else {
		print "Error: I could not open the file $p_dir/source/src-setup-$method\n";
		print "for reading (reason: $!).  Check permissions and check that you\n";
		print "have properly extracted the archive, then try again.\n\n";
		exit(0);
	} 
	foreach $line (@method) {
		$line =~ s/\\/\\\\/g;
		$line =~ s/\@/\\\@/g;
		$line =~ s/"/\\"/g;
		$line =~ s/\n/\\n/g;
		print FILE "print \"$line\";\n";
	}
	print FILE "}\n";
	print FILE "\n";
	close (FILE);
} else {
	print "Error: could not write to '$chosen_dir/board-setup.$cgi_extension'\n";
	print "probably because you don't have write permissions to that directory.\n";
	&press_key if $windows;
	exit(0);
}

eval 'chmod (0755, "$chosen_dir/board-setup.$cgi_extension");';

print "Created and wrote board-setup.$cgi_extension\n";

print "-" x 50, "\n\n";
print "It is now time to access the setup form.  Using your web browser,\n";
print "access the board-setup.$cgi_extension file using a URL such as:\n\n";
print "\thttp://your.server.com/whatever/board-setup.$cgi_extension\n\n";
print "(Leave this telnet session open if you can, as you will be returning\n";
print "to finish the installation in a few moments.)\n\n";

if ($windows) {
	&press_key;
}
exit(0);

###################################################################
# Miscellaneous Subroutines

sub press_key {
	print "\n";
	print "-" x 60, "\n";
	print "   Please press ENTER to continue with setup\n";
	print "-" x 60, "\n";
	$f = <STDIN>;
	print "\n";
}

sub test_perl {
	local ($perlin) = @_;
	return 2 if !$unix;
	$cmd = "$perlin -e 'print \"Howdy\";'";
	if (-x $perlin) {
		$result = `$cmd`;
		if ($result =~ /^Howdy/) {
			return 2;
		} 
	}
	return 0;
}

sub divider {
	print "\n" x 20;
	print ">", "=" x 58, "<", "\n";
	print "\n";
}
