###########################################################
# COPYRIGHT NOTICE - DO NOT REMOVE
# This upgrade script, as well as the Discus program, is
# copyright (c) 1998 by DiscusWare, LLC, all rights
# reserved.  It is subject to license agreements which
# are detailed on the Discus home page:
#    http://www.chem.hope.edu/discus

###########################################################
# The Discus team sets these variables appropriate to the
# version that you need to upgrade.

$thisversion = "3.10";
$pro_version = 1;

###########################################################
# Note:  if you set pro=1 or you use this option, but you
# haven't purchased Pro, it won't work!  There are some
# files that are not present in the non-pro distribution
# that are required to run the pro version.

$pro_version = 1;

###########################################################
# Interactive portion of the upgrade

print "\n\n";

if (open (FILELIST, "source/filelist.txt")) {
	@filelist = <FILELIST>;
	close (FILELIST);
} else {
	chmod (0755, "source");
	if (open (FILELIST, "source/filelist.txt")) {
		@filelist = <FILELIST>;
		close (FILELIST);
	} else {	
		print "Error upgrading:  Could not open your file list in source/filelist.txt\n";
		print "Reason: $!\n\n";
		print "Possible actions:\n";
		print " 1) Make sure you did a 'cd' into the discus3_?? directory\n";
		print " 2) Make sure the 'source' subdirectory exists\n";
		print " 3) Issue 'chmod 0755 source' to make the source directory readable\n";
		print " 4) Make sure your distribution contains a file called filelist.txt\n";
		print " 5) Issue '(cd source; chmod 0644 *)' to make all files readable.\n\n";
		exit(0);
	}
}

$proflag = " PRO" if $pro_version == 1;
if (-d "C:/" || $^O eq "MSWin32") {
	$windows = 1;
	$platform = "WINDOWS";
} elsif (-e "/etc/passwd") {
	$unix = 1;
	$platform = "UNIX";
} else {
	$unix = 1;
	$platform = "UNKNOWN PLATFORM";
}

print "\n\n";
print "WELCOME TO DISCUS $thisversion ";
print "PRO " if $pro_version;
print "SETUP FOR $platform\n\n";

if (open(SRC, "./source/src-board-subs-common")) {
	@src = <SRC>;
	close (SRC);
	@src = grep(/^\$/, @src);
	undef %SRC_VAR;
	foreach $line (@src) {
		if ($line =~ m|^\$(\w+)\s*=\s*"(.*)";|) {
			$SRC_VAR{$1} = $2;
		}
	}
	print "This will upgrade you to Discus $SRC_VAR{'release_version'}.";
	print "$SRC_VAR{'free_revision'} (Freeware)" if !$pro_version;
	print "$SRC_VAR{'pro_revision'} PRO" if $pro_version;
	print ".\n";
	if ($SRC_VAR{'free_revision'} =~ m|b| || $SRC_VAR{'pro_revision'} =~ m|b|) {
		print "NOTE:  THIS IS A BETA VERSION!!!\n";
	}
	print "\nIf you were expecting a different version of Discus, you should obtain\n";
	print "the correct distribution.  Freeware Discus can be downloaded from:\n";
	print "   http://www.discusware.com/discus/download.html\n";
	print "Discus Pro must be downloaded from the Discus Pro download area:\n";
	print "   http://www.discusware.com/pro/download.html\n\n";
	&press_key;
}

print <<EOF;
Welcome to Discus $thisversion$proflag interactive upgrade!  This script
will ask you a few questions and then it will automatically
upgrade your installation of Discus to version $thisversion$proflag.

EOF

print "It is strongly recommended that you make a backup of all\n";
print "of your Discus files (including administration files, static\n";
print "HTML files, script files, and message files) before continuing.\n";
print "Have you made this backup? (Type Y for yes or N for no)\n\n";
print "YOUR ANSWER>  ";
$yn = <STDIN>;
exit(0) if $yn !~ m|^[yY]|;
print "\n";
print "In what directory is the \"discus.conf\" file from the\n";
print "previous installation of Discus?\n\n";
print "INPUT>  ";
$dcdir = <STDIN>;
chop ($dcdir);
$dcdir =~ s/\/$//;
if (!(open (DC, "$dcdir/discus.conf"))) {
	print "OOPS!  I couldn't find \"discus.conf\" there.\n\n";
	exit(0);
} else {
	@DC = <DC>;
	close (DC);
	foreach $line (@DC) {
		chop ($line) if $line =~ /\n$/;
		($param, $value) = split(/=/, $line, 2);
		$VAR{$param} = $value;
	}
}

$installation = "2.15";
$title_stripped = $VAR{'title'};
$title_stripped =~ s/<[^>]*>//g;
$title_stripped =~ s/&#(\d+);//g;

if ($VAR{'version'} ne "") {
	$installation = $VAR{'version'};
} else {
	print "\nCHOOSE PREVIOUS VERSION\n\n";
	print "I could not determine what version your board is running now.\n";
	print "This generally indicates that the version is 2.15 or earlier.\n";
	print "Please tell me what version you are running:\n\n";
	print "1)  Version 2.15 or before\n";
	print "2)  Version 2.20 or later\n";
	print "\n";
	print "YOUR ANSWER> ";
	$ans = <STDIN>;
	if ($ans == 1) {
		$installation = "2.15";
	} elsif ($ans == 2) {
		$installation = "2.20";
	} else {
		print "Bad answer!\n\n";
		exit(0);
	}
}	

if ($VAR{'platform'} =~ /unix/i) {
	$unix = 1;
} elsif ($VAR{'platform'} =~ /win95/i) {
	$win95 = 1;
} elsif ($VAR{'platform'} =~ /nt/i) {
	$winnt = 1;
} elsif ($^O eq "MSWin32") {
	$winnt = 1;
} else {
	$unix = 1;
}

if ($pro_version == 1) {
	$flag = 1;
	print "\nDISCUS PRO LICENSE NUMBER\n\n";
	print "Please enter your Discus Pro license number.  This license number\n";
	print "will have the form ####-####-####.  If you did not receive this\n";
	print "license number from Discus, please e-mail sales\@discusware.com.\n\n";
	while ($flag == 1) {
		print "ENTER LICENSE NUMBER>  ";
		$pro_license = <STDIN>;
		chop ($pro_license);
	
	# There is not anything in the script that would break if you gave a wrong license
	# number.  This is entered for YOUR protection, so you know that you paid, should
	# this ever become an issue.  Thus, we STRONGLY recommend entering a real license
	# number.  You have been told.  Besides, do you think it is wise to use pirated
	# software in a networked environment where you are so easily caught?
	
		if ($pro_license eq "") {
			print "Please visit the website http://www.chem.hope.edu/discus/pro to purchase\n";
			print "a license and to receive a license number.\n\n";
			exit(0);
		} elsif ($pro_license !~ m|^\d\d\d\d-\d\d\d\d-\d\d\d\d|) {
			print "That license number is not in the form ####-####-####.  Please check\n";
			print "your license number and try again.\n\n";
		} elsif ($pro_license eq "0000-0000-0000") {
			print "Please visit the website http://www.chem.hope.edu/discus/pro to purchase\n";
			print "a license and to receive a license number.\n\n";
			exit(0);
		} else {
		
			# This operation is check-summing your license information to help you catch
			# typographical errors.  Sure, you could easily circumvent it, but why would
			# you want to do that, unless you didn't have a valid license number!?!
		
			($first, $second, $third) = split(/-/, $pro_license);
			
			$f[0] = substr($first, 0, 1);
			$f[1] = substr($first, 1, 1);
			$f[2] = substr($first, 2, 1);
			$f[3] = substr($first, 3, 1);
			$s[0] = substr($second, 0, 1);
			$s[1] = substr($second, 1, 1);
			$s[2] = substr($second, 2, 1);
			$s[3] = substr($second, 3, 1);
			$t[0] = substr($third, 0, 1);
			$t[1] = substr($third, 1, 1);
			$t[2] = substr($third, 2, 1);
			$t[3] = substr($third, 3, 1);
			
			if ((($f[0] + $s[0]) % 10 != $t[0]) || (($f[1] + $s[1]) % 10 != $t[1]) || (($f[2] + $s[2]) % 10 != $t[2]) || (($f[3] + $s[3]) % 10 != $t[3])) {
				print "The license number you entered is not valid.  Please double-check\n";
				print "your license number and try again.\n\n";
			} else {
				last;
			}
		}
	}
}

print "\n";
print "-" x 60, "\n";
print "CHOOSE TYPE OF UPGRADE\n\n";
print "There are two types of upgrades you can perform at this time: a typical\n";
print "upgrade and a custom upgrade.\n\n";
print "A typical upgrade installs scripts, source files, templates, and HTML files.\n";
print "This is a good option if you have not customized any of the static HTML files\n";
print "(such as the main menu and the instructions).  All topics, messages, password\n";
print "data, and logs will be preserved.\n\n";
print "A custom upgrade should be used if you have customized static HTML files\n";
print "or templates, or if you need to reinstall Discus because it is now failing to\n";
print "work because of customizations that you made.  You will be asked to pick and\n";
print "choose which files will be overwritten.\n\n";
print "Choose your upgrade method:\n\n";
print "1) Typical upgrade\n";
print "2) Custom upgrade\n";
print "\n";
print "YOUR ANSWER>  ";
$upgradetype = <STDIN>;
chop ($upgradetype);
if ($upgradetype != 1 && $upgradetype != 2) {
	print "OOPS!  That wasn't a 1 or a 2!\n\n";
	exit(0);
}
if ($upgradetype == 2) {
	print "-" x 60, "\n";
	undef %CUSTOM;
	if (-e "./custom$thisversion.cache") {
		print "I see a file here that stored your custom upgrade options from the\n";
		print "last time you upgraded Discus.  Would you like me to use this file\n";
		print "to set the defaults for this upgrade?  (Enter Y or N):\n\n";
		print "YOUR ANSWER> ";
		$yn = <STDIN>;
		if ($yn =~ m|^[yY]|) {
			open (FILE, "./custom$thisversion.cache");
			while (<FILE>) {
				if (m|^(\d+)=(\w+)|) {
					$CUSTOM{$1} = $2;
				}
			}
			close (FILE);
		}
	}
	open (CUSTOM, ">./custom$thisversion.cache");
	print CUSTOM "#Upgrade selection for Discus $thisversion.\n";	
	print "CUSTOM UPGRADE OPTION SELECTIONS\n\n";
	print "You will now have the option to select your custom upgrade\n";
	print "options.  The default value will be shown in [brackets], and\n";
	print "if you just hit RETURN without typing anything, the default\n";
	print "will be used.  If you decide that you really must leave, type\n";
	print "q and press RETURN and you'll exit the script.\n\n";
	print "STATIC HTML DOCUMENTS (documentation, menu, etc):\n\n";
	&inquire(1, "Overwrite board.html (frame-setting document)", "Y");
	&inquire(2, "Overwrite board-instructions.html ('Getting Started')", "Y");
	&inquire(4, "Overwrite board-formatting.html ('Formatting')", "Y");
	&inquire(5, "Overwrite board-troubleshooting.html ('Troubleshooting')", "Y");
	&inquire(6, "Overwrite board-about.html ('Program Credits')", "Y");
	&inquire(7, "Overwrite board-menu.html (Board menu)", "Y");
	&inquire(8, "Overwrite administration instructions", "Y");
	&inquire(9, "Overwrite index.html for board", "Y");
	&inquire(10, "Overwrite admin.html (administration frame-setter)", "Y");
	&inquire(11, "Overwrite warning.html (administration warning)", "Y");
	print "\nDYNAMIC HTML DOCUMENTS (topic files):\n\n";
	&inquire(12, "Warning! If you answer yes to this question, you will lose\n\tall topics on your board!\n\tOverwrite board-topics.html (topics page)", "N");
	print "\nIMAGE FILES (clipart, icons):\n\n";
	&inquire(13, "Overwrite clipart (board logo, smile face, ...)", "N");
	&inquire(14, "Overwrite icons (administration icons)", "N");
	print "\nTEMPLATE FILES:\n\n";
	&inquire(15, "Overwrite 'Add Message' boxes", "Y");
	&inquire(16, "Overwrite newpage.conf file (page template)", "Y");
	print "\nCONFIGURATION FILES:\n\n";
	&inquire(17, "Overwrite language.conf/language_pro.conf files (dynamic UI text)", "Y");
	&inquire(18, "Overwrite attachments.conf file (attachment configuration)", "Y") if $pro_version;
	&inquire(19, "Overwrite webtags.conf file (formatting configuration)", "Y");
	&inquire(20, "Overwrite messages.conf file (messages template)", "Y");
	&inquire(21, "Overwrite subtopics.conf file (subtopics template)", "Y");
	&inquire(22, "Overwrite topics.conf file (topics template)", "Y");
	&inquire(23, "Overwrite newprofile.conf file (basis for new profiles)", "Y");
	&inquire(24, "Overwrite stopwords.conf file (for search engine)", "Y");
	&inquire(25, "Overwrite charconvert.conf file (character translations)", "Y");
	close(CUSTOM);
}

if (-e "./source/languages") {
	$count = 1;
	undef %lang; $language = "";
	$lang{1} = "English";
	opendir(DIR, "./source/languages");
	while ($dir = readdir(DIR)) {
		if ($dir =~ m|^\w+$|) {
			$count += 1;
			$lang{$count} = $dir;
		}
	}
	closedir(DIR);
	print "\n\n";
	print "SELECT LANGUAGE\n\n";
	print "Please choose the language you wish to install:\n\n";
	for ($i = 1; $i <= $count; $i++) {
		print "$i) \u$lang{$i}\n";
	}
	print "\n";
	print "Your answer: ";
	$lang = <STDIN>; chomp $lang;
	if ($lang < 1 || $lang > $count) {
		print "Invalid selection!\n";
		exit(0);
	}
	$language_selected = $lang{$lang} if $lang >= 2;
}

print "\n\n";
print "Are you sure that you want to upgrade your board from version ";
print "$installation\n" if $installation ne "2.15";
print "2.15 or before\n" if $installation eq "2.15";
print "to the new version $thisversion";
print " PRO" if $pro_version;
print "? ";
print "(Type Y for yes or N for no)\n\n";
print "YOUR ANSWER>  ";
$answer = <STDIN>;
exit(0) if $answer !~ /^[yY]/;

print "-" x 60, "\n";
print "MAKING CHANGES...\n\n";
print "I will now make the requested changes.  This may take several seconds\n";
print "to a minute.  Please be patient...\n\n";

######################################################################
# WRITE SOME NEW/UPDATED INFORMATION TO DISCUS.CONF

if ($VAR{'version'} eq "") {
	open (DC, ">>$dcdir/discus.conf");
	print DC "version=$thisversion\n";
	close (DC);
} else {
	open (DC, "$dcdir/discus.conf");
	@dc = <DC>;
	close (DC);
	open (DC, ">$dcdir/discus.conf");
	foreach $line (@dc) {
		if ($line =~ /^version/) {
			print DC "version=$thisversion\n";
		} else {
			print DC $line;
		}
	}
	close (DC);
}

open (DC, "$dcdir/discus.conf");
@dc = <DC>;
close (DC);
@dc = grep(!/^pro=/, @dc);
push (@dc, "pro=$pro_version\n");
open (DC, ">$dcdir/discus.conf");
print DC @dc;
close (DC);

if ($VAR{'platform'} eq "") {
	open (DC, ">>$dcdir/discus.conf");
	print DC "platform=Unix\n" if $unix;
	print DC "platform=Win95\n" if $win95;
	print DC "platform=NT\n" if $winnt;
	close (DC);
} else {
	open (DC, "$dcdir/discus.conf");
	@dc = <DC>;
	close (DC);
	open (DC, ">$dcdir/discus.conf");
	foreach $line (@dc) {
		if ($line =~ /^platform/) {
			print DC "platform=Unix\n" if $unix;
			print DC "platform=Win95\n" if $win95;
			print DC "platform=NT\n" if $winnt;
		} else {
			print DC $line;
		}
	}
	close (DC);
}

chmod(0644,"$dcdir/discus.conf");

########################################################################
# NEW METHODS OF REFERENCE IN VERSION 2.41+

if ($VAR{'admin_dir_'} eq "") {
	$VAR{'admin_dir_'} = "$VAR{'prepend'}$VAR{'admin_dir'}";
	$VAR{'html_dir_'} = "$VAR{'prepend'}$VAR{'html_dir'}";
	$VAR{'script_dir_'} = "$VAR{'prepend'}$VAR{'script_dir'}";
	open (DCONF, ">>$dcdir/discus.conf");
	print DCONF "admin_dir_=$VAR{'admin_dir_'}\n";
	print DCONF "html_dir_=$VAR{'html_dir_'}\n";
	print DCONF "script_dir_=$VAR{'script_dir_'}\n";
	close (DCONF);
	open (DCONF, "$dcdir/discus.conf");
	@dc = <DCONF>;
	close (DCONF);
	@dc = grep(!/^prepend=/,@dc);
	open (DCONF, ">$dcdir/discus.conf");
	print DCONF @dc;
	close (DCONF);
}

$admin_dir_ = $VAR{'admin_dir_'};
$html_dir_ = $VAR{'html_dir_'};
$script_dir_ = $VAR{'script_dir_'};
$cgi_extension = $VAR{'cgi_extension'};

######################################################################
# UPGRADE PREVIOUS GROUPS.TXT, PASSWD.TXT, USERS.TXT FILES TO THE NEW
# DISCUS 2.20+ FORMAT -- THIS IS REQUIRED FOR EARLIER VERSIONS!
# Some of this will again be upgraded going from 2.50 -> 3.00

if ($installation eq "2.15") {
	print "Upgrading \"groups.txt\" to new format.\n";
	open (GROUP, "$VAR{'admin_dir_'}/groups.txt");
	@group_file = <GROUP>;
	close (GROUP);
	open (GROUP, ">$VAR{'admin_dir_'}/groups.txt.old");
	foreach $line (@group_file) {
		print GROUP $line;
	}
	close (GROUP);
	undef %groups;
	foreach $line (sort(@group_file)) {
		chop ($line) if $line =~ /\n$/;
		($group, $user) = split(/:/, $line);
		$groups{$group} .= "$user,";
	}
	open (GROUP, ">$VAR{'admin_dir_'}/groups.txt");
	foreach $grp (sort(keys(%groups))) {
		$groups{$grp} =~ s/,$//g;
		print GROUP "$grp:$groups{$grp}\n";
	}
	close (GROUP);
	eval 'chmod (0666, "$admin_dir_/groups.txt");';
	print "Upgrading \"passwd.txt\" to new format.\n";
	open (PW, "$VAR{'admin_dir'}/passwd.txt");
	@passwd_file = <PW>;
	close (PW);
	open (PW, ">$VAR{'admin_dir_'}/passwd.txt.old");
	foreach $line (@passwd_file) {
		print PW $line;
	}
	close (PW);
	open (PW, ">$VAR{'admin_dir_'}/passwd.txt");
	foreach $line (sort(@passwd_file)) {
		chop ($line) if $line =~ /\n$/;
		($username, $encpass, $email) = split(/:/, $line);
		print PW "$username:$encpass:$email:fullname:1:0:0\n";
	}
	close (PW);
	eval 'chmod (0666, "$admin_dir_/passwd.txt");';
	print "Upgrading \"users.txt\" to new format.\n";
	open (USERS, "$VAR{'admin_dir_'}/users.txt");
	@users = <USERS>;
	close (USERS);
	open (USERS, ">$VAR{'admin_dir_'}/users.txt.old");
	foreach $line (@users) {
		print USERS $line;
	}
	close (USERS);
	undef %user;
	undef %group;
	undef @user;
	srand (time|$$);
	undef %userlist;
	foreach $line (@users) {
		chop ($line) if $line =~ /\n$/;
		($user, $pass, $group) = split(/:/, $line);
		if ($user eq "public") {
			push (@user, "PUBLIC:::PUBLIC USER - DO NOT MODIFY:0:0:0:$group\n");
		} elsif ($user eq "users") {
			push (@user, "USERS:::USERS USER - DO NOT MODIFY:0:0:0:$group\n");
		} elsif ($user eq "moderators") {
			push (@user, "MODERATORS:::MODERATORS USER - DO NOT MODIFY:0:0:0:$group\n");
		} else {
			undef @salt;
			for ($i = 0; $i <= 3; $i++) {
				push (@salt, int(rand(26)) + 65);
			}
			$salt = pack('cccc', @salt);
			$encr_pass = crypt($pass, $salt);
			$encr_pass = "*" if $pass eq "";
			if (grep(/^$user$/, split(/,/, $userlist{$group}))) {
				print "WARNING:  $user already exists in $group.\n";
				print "  $user:$pass renamed to ";
				$n = 1;
				while (grep(/^$user$n$/, split(/,/, $userlist{$group}))) {
					$n += 1;
				}
				print "$user$n\n";
				$user .= $n;
			}
			$userlist{$group} .= ",$user";
			$string = "$user:$encr_pass";
			$string .= ":email:fullname:1:0:0:$group\n";
			push (@user, $string);
		}
	}
	open (USERS, ">$VAR{'admin_dir_'}/users.txt");
	print USERS sort(@user);
	close (USERS);
	eval 'chmod(0666, "$admin_dir_/users.txt");';
}

########################################################################
# FIND THE PATH TO PERL

open (FILE, "$VAR{'script_dir_'}/board-admin.$VAR{'cgi_extension'}");
@file = <FILE>;
close (FILE);
foreach $line (@file) {
	$chosen_perl = $line if $line =~ /^#!/;
	last if $line =~ /^#!/;
}
$chosen_perl =~ s/\s$//g;
$chosen_perl =~ s/^#!//;
$chosen_perl =~ s/\s/%20/g;

########################################################################
# FIND THE DISCUS PRO FILE ID NUMBER

$pro_fileid = "";
$VAR{'admin_dir_'} = $VAR{'admin_dir'} if $VAR{'admin_dir_'} eq "";
if ($pro_version == 1) {
	opendir(SOURCE, "$VAR{'admin_dir_'}/source");
	while ($file = readdir(SOURCE)) {
		if ($file =~ m|src-board-subs-(\d+)_(\d+)|) {
			$pro_fileid = $2;
			last;
		}
	}
	closedir (SOURCE);
}
if ($pro_version == 1 && $pro_fileid eq "") {
	srand (time|$$);
	$rn = int(rand(9999));
	$pn = $$; $pn =~ s/\D//g;
	$tm = time; $tm =~ s/\D//g;
	$pro_fileid = join("", $rn, $pn, $tm);
}

########################################################################
# Upgrade version 2.15 -> version 2.20 file format if necessary

if ($installation eq "2.15") {
	open (TOPICS, "$VAR{'html_dir_'}/messages/board-topics.html");
	@topics = <TOPICS>;
	close (TOPICS);
	foreach $line (@topics) {
		if ($line =~ /<!-Top: (\d+)-!>/) {
			$one = $1;
			&fix_hr($one, $one) if $installation eq "2.15";
		}
	}
}

########################################################################
# Copy the new files from the packing list

if (open (FILELIST, "./source/filelist.txt")) {
	@filelist = <FILELIST>;
	close (FILELIST);
} else {
	print "Error upgrading:  Could not open your file list in source/filelist.txt\n";
	print "Reason: $!\n\n";
	exit(0);
}
@filelist = grep(/\S/, @filelist);
@filelist = grep(!/^#/, @filelist);
foreach $line (@filelist) {
	if ($line =~ m|^(\S+)\s+(\S+)\s+\[(\S+)\]|) {
		($perm, $file, $param) = ($1, $2, $3);
	} elsif ($line =~ m|^(\S+)\s+(\S+)|) {
		($perm, $file, $param) = ($1, $2, "");
	} else {
		next;
	}
	$perm =~ m|(.)(.)(.)(.)(.)(.)(.)(.)(.)(.)|;
	($dir, $ur, $uw, $ux, $gr, $gw, $gx, $or, $ow, $ox) = ($1, $2, $3, $4, $5, $6, $7, $8, $9, $10);
	$uperm = 0; $gperm = 0; $operm = 0;
	$uperm += 4 if $ur ne "-";
	$uperm += 2 if $uw ne "-";
	$uperm += 1 if $ux ne "-";
	$gperm += 4 if $gr ne "-";
	$gperm += 2 if $gw ne "-";
	$gperm += 1 if $gx ne "-";
	$operm += 4 if $or ne "-";
	$operm += 2 if $ow ne "-";
	$operm += 1 if $ox ne "-";
	$perm = "$uperm$gperm$operm";
	if ($dir ne "d") {
		if ($file =~ m|^./discus_admin/(.*)|) {
			$fn = $1;
			$destfile = "$VAR{'admin_dir_'}/$fn";
			if ($fn =~ m|(.*)/(\S+)\.|) {
				$source = "src-$2";
			} elsif ($fn =~ m|(.*)/(\S+)|) {
				$source = "$2";
			} elsif ($fn =~ m|(\S+)\.|) {
				$source = "src-$1";
			} else {
				$source = $fn;
			}
			&process_file($source, $destfile, $perm, $param);
		} elsif ($file =~ m|^./public_html/(.*)|) {
			$fn = $1;
			$destfile = "$VAR{'html_dir_'}/$fn";
			if ($fn =~ m|(.*)/(\S+)\.gif|) {
				$source = "img-$2";
			} elsif ($fn =~ m|(.*)/(\S+)\.|) {
				$source = "src-$2";
			} elsif ($fn =~ m|(\S+)\.|) {
				$source = "src-$1";
			} else {
				$source = $fn;
			}
			&process_file($source, $destfile, $perm, $param);
		} elsif ($file =~ m|^./cgi-bin/(.*)\.|) {
			$fn = $1 . ".$VAR{'cgi_extension'}";
			$destfile = "$VAR{'script_dir_'}/$fn";
			if ($fn =~ m|(\S+)\.|) {
				$source = "src-$1";
			} else {
				$source = $fn;
			}
			&process_file($source, $destfile, $perm, $param);
		}
	} else {
		next if ($param =~ m|\%| && !$pro_version);
		if ($file =~ m|^./discus_admin/(.*)|) {
			$dirname = $VAR{'admin_dir_'} . "/$1";
		} elsif ($file =~ m|^./public_html/(.*)|) {
			$dirname = $VAR{'html_dir_'} . "/$1";
		} elsif ($file =~ m|^./cgi-bin/(.*)|) {
			$dirname = $VAR{'script_dir_'} . "/$1";
		}
		if (-e $dirname) {
			chmod(oct($perm), $dirname);
		} else {
			mkdir ($dirname, oct($perm));
			chmod (oct($perm), $dirname);
		}
	}
}

########################################################################
# Print final good-bye message

print "The new version of Discus has been installed!\n";
print "Now you must log into administration as the superuser.\n";
print "You will be prompted to follow the upgrade procedure if necessary.\n\n";

&press_key;
exit(0);

########################################################################
# PRESS KEY subroutine

sub press_key {
	print "\n";
	print "-" x 60, "\n";
	print "   Please press ENTER to continue the upgrade procedure\n";
	print "-" x 60, "\n";
	$foobar = <STDIN>;
	print "\n";
}

########################################################################
# INQUIRE subroutine

sub inquire {
	local ($idnum, $question, $default) = @_;
	$default = $CUSTOM{$idnum} if $CUSTOM{$idnum} ne "";
	print "$question? [$default] ";
	$a = <STDIN>;
	chop $a;
	if ($a =~ m|^[yY]|) {
		$Q{$idnum} = 1;
		print CUSTOM "$idnum=Y\n";
	} elsif ($a =~ m|^[nN]|) {
		$Q{$idnum} = 2;
		print CUSTOM "$idnum=N\n";
	} else {
		$Q{$idnum} = 1 if $default =~ m|^[yY]|;
		$Q{$idnum} = 2 if $default =~ m|^[nN]|;
		print CUSTOM "$idnum=$default\n";
	}
}

########################################################################
# PROCESS FILE subroutine

sub process_file {
	local ($source, $destfile, $perm, $param) = @_;
	if ($param =~ m|\%| && $pro_version == 0) {
		return 0;
	}
	$binmode = 0; $html = 0; $cgi = 0; $force = 0; $doflag = 0;
	$binmode = 1 if $param =~ m|B|;
	$html = 1 if $param =~ m|H|;
	$cgi = 1 if $param =~ m|C|;
	if ($param =~ m|c|) {
		$source .= "-frames" if $VAR{'interface'} ne "noframes";
		$source .= "-noframes" if $VAR{'interface'} eq "noframes";
	}
	$force = 0;
	if ($param =~ m|<([\d\.]+)>|) {
		$param = join("", $`, $');
		$version = $1;
		$force = 1 if $version > $VAR{'version'};
	}
	$force = 1 if ($VAR{'pro'} == 0 && $pro_version == 1 && $param =~ m|\%|);
	if ($param =~ m|(\d+)|) {
		$i = $1;
		if ($param =~ m|N|) {
			$doflag = 1 if $Q{$i} == 1;
		} else {
			$doflag = 1 if $Q{$i} != 2;
		}
	} else {
		$doflag = 1;
	}
	$doflag = 1 if $force == 1;	
	$destfile .= "_$pro_fileid" if $param =~ m|h|;
	$source = "" if $param =~ m|X|;
	$source_c = "";
	$source_c = "Order deny,allow\nDeny from all\nAllow from none\n" if $param =~ m|~|;
	$source_c = "<FILES *>\nRestrictAccess type=deny ip=*\n</FILES>\n" if $param =~ m|\`|;
	$source = "**" if $param =~ m|~|;
	$source = "**" if $param =~ m|\`|;
	if ($param =~ m|i|) {
		$source = "src-board" if $VAR{'interface'} ne "noframes";
		$source = "src-board-refresh" if $VAR{'interface'} eq "noframes";
	}
	if ($param =~ m|\*|) {
		if (-e $destfile) {
			chmod (oct($perm), $destfile);
			return 0 if -e $destfile;
		}
		$source = "**" if !-e "./source/$source";
	}
	if ($doflag) {	
		&file_copy($source, $destfile, $binmode, $cgi, $html, $perm, $source_c);
	}
}

########################################################################
# FILE COPY subroutine

sub file_copy {
	local ($sourcefile, $destfile, $binary, $script_flag, $html_flag, $permissions, $source_c) = @_;
	if ($sourcefile eq "**") {
		$sourcefile = "";
		$source_cd = $source_c;
		$source_cd = "\n" if $source_c eq "";
	} else {
		$source_cd = "";
	}
	$sf = "./source/$sourcefile" if $language_selected eq "";
	if ($language_selected) {
		$sf = "./source/languages/$language_selected/$sourcefile" if -e "./source/languages/$language_selected/$sourcefile";
		$sf = "./source/$sourcefile" if !-e "./source/languages/$language_selected/$sourcefile";
	}
	if (open(SOURCE, "$sf") || $sourcefile eq "") {
		eval 'binmode(SOURCE);' if $binary;
		@source = <SOURCE>;
		close (SOURCE);
		if ($source_cd ne "") {
			@source = split(/\n/, $source_cd);
			foreach $line (@source) {
				$line .= "\n";
			}
		}
		if (open (DEST, ">$destfile")) {
			eval 'binmode(DEST);' if $binary;
			if ($script_flag) {
				print DEST "#!$chosen_perl\n";
				print DEST "\$discus_conf = '$VAR{\"admin_dir\"}/discus.conf';\n";
				print DEST "\$pro_fileid = '$pro_fileid';\n" if $pro_fileid ne "";
				print DEST "\$pro_license = '$pro_license';\n" if $pro_license ne "";
			}
			if ($html_flag) {
				foreach $line (@source) {
					$flag = 0;
					until ($flag == 1) {
						$flag = 1;
						if ($line =~ /"board-menu\.html/) {
							$line = "$`\"$VAR{'html_url'}/board-menu.html$'"; $flag = 0;
						} elsif ($line =~ m|"messages/board-topics.html|) {
							$line = "$`\"$VAR{'html_url'}/messages/board-topics.html$'"; $flag = 0;
						} elsif ($line =~ /"board-search.cgi/) {
							$line = "$`\"$VAR{'script_url'}/board-search.$VAR{'cgi_extension'}$'"; $flag = 0;
						} elsif ($line =~ /"board-viewtree.cgi/) {
							$line = "$`\"$VAR{'script_url'}/board-viewtree.$VAR{'cgi_extension'}$'"; $flag = 0;
						} elsif ($line =~ /"board-newmessages.cgi/) {
							$line = "$`\"$VAR{'script_url'}/board-newmessages.$VAR{'cgi_extension'}$'"; $flag = 0;
						} elsif ($line =~ /"board-profile.cgi/) {
							$line = "$`\"$VAR{'script_url'}/board-profile.$VAR{'cgi_extension'}$'"; $flag = 0;
						} elsif ($line =~ /"board-contact.cgi/) {
							$line = "$`\"$VAR{'script_url'}/board-contact.$VAR{'cgi_extension'}$'"; $flag = 0;
						} elsif ($line =~ /"board-image-lister.cgi/) {
							$line = "$`\"$VAR{'script_url'}/board-image-lister.$VAR{'cgi_extension'}$'"; $flag = 0;
						} elsif ($line =~ /"board-admin-menuonly.cgi/) {
							$line = "$`\"$VAR{'script_url'}/board-admin-menuonly.$VAR{'cgi_extension'}$'"; $flag = 0;
						} elsif ($line =~ /"warning.html/) {
							$line = "$`\"$VAR{'html_url'}/warning.html$'"; $flag = 0;
						} elsif ($line =~ /\.\.\/clipart\/board_logo.gif/) {
							$line = "$`$VAR{'html_url'}/clipart/board_logo.gif$'"; $flag = 0;
						} elsif ($line =~ /^<!-Pro-!>/ && $pro_version == 0) {
							$line = "";
						}
					}
				}
				$title = $VAR{'title'};
				foreach $line (@source) {
					$line =~ s/<!--\*-->([^!]+)<!--\/\*-->/<!--\*-->$title<!--\/\*-->/g;
					$line =~ s/<!--TITLE-->([^!]+)<!--\/TITLE-->/<!--TITLE--><TITLE>$title<\/TITLE><!--\/TITLE-->/g;
				}
			}
			print DEST @source;
			close (DEST);
			chmod (oct($permissions), $destfile);
		} else {
			print "Warning: Could not write $destfile: $!\n";
			close (SOURCE);
		}		
	} else {
		print "Warning: Could not open $sourcefile: $!\n";
	}
}

########################################################################
# Upgrade version 2.15 or before to version 2.20 or later files

sub fix_hr {
	local ($topic, $page) = @_;
	local (@file, $line, $filename);
	$filename = "$VAR{'html_dir_'}/messages/$topic/$page.$VAR{'ext'}";
	open (FILE, $filename);
	@file = <FILE>;
	close (FILE);
	foreach $line (@file) {
		if ($line =~ /<!-Top: (\d+)-!>/) {
			&fix_hr($topic, $1);
		}
	}
	$flag = 0;
	open (FILE, ">$filename");
	foreach $line (@file) {
		if ($line =~ /<!--Messages/) {
			$flag = 1;
			print FILE $line;
		} elsif ($line =~ /^<HR>\s+$/ && $flag == 1) {
			# Skip
		} elsif ($line =~ /<!-Post:/) {
			print FILE $line;
			print FILE "<HR>\n";
		} elsif ($line =~ /<!--Add-->/) {
			print FILE $line;
			print FILE "<HR>\n";
		} else {
			print FILE $line;
		}
	}
	close (FILE);
	chmod (0666, $filename);
}

